var loadMM = new Array();
var saveMM = new Array();
var loadMMflag = new Boolean(false);

// File API実装チェック
window.onload = function(){
  if (window.File) {
    // File APIが実装されている場合には、dropイベントを登録
    document.getElementById("drop").addEventListener("drop", onDrop, false);
  } else {
    window.alert("このブラウザは対応していません。\nFile API に対応したブラウザを使ってください。");
  }

  // 変数の初期化
  for(i = 0; i < 32; i++) {
    loadMM[i] = 0;
  }
  loadMMflag = false;
}

// Drop領域にドロップした際のファイルの読み取り処理
function onDrop(event) {
  var files = event.dataTransfer.files;
  var disp = document.getElementById("disp");
  disp.innerHTML ="";

  // ファイルの配列の先頭ファイルを選択
  var f = files[0];
  // FileReaderオブジェクトの生成
  var reader = new FileReader();

  // テキスト・ファイルかを判定
  if (!f.type.match('text.*')) {
    disp.innerHTML ="テキスト以外は読み込めません。";
  }

  // エラー発生時の処理
  reader.onerror = function (evt) {
    disp.innerHTML = "読み取り時にエラーが発生しました。";
  }

  // テキスト・ファイルの場合の処理
  if (f.type.match('text.*')) {
    // ファイル読取が完了した際に呼ばれる処理
    reader.onload = function (evt) {
      // FileReaderが取得したテキストから配列に
      line = reader.result.split("\n");
      if(line[0].slice(0, 3) == "00:") {
        // フォーマットはOK
        for(i = 0; i < line.length; i++) {
          // バイナリ部分だけ（残りは無視）を数字にして配列に
	  data = 0;
          for(j = 0; j < 8; j++) {
            if(line[i].charAt(j+4) == "1") {
              data += (1 << (7-j));
            }
          }
          loadMM[i] = data;
        }
        loadMMflag = true;

        disp.innerHTML = "ファイル“"+f.name+"”を読み込みました。";
      } else {
        disp.innerHTML = "ファイル“"+f.name+"”はフォーマットが違います。";
      }
    }
    // readAsTextメソッドでファイルの内容を取得
    reader.readAsText(f, 'shift-jis');
  }
  // ブラウザ上でファイルを展開する挙動を抑止
  event.preventDefault();
}

function onDragOver(event) { 
  // ブラウザ上でファイルを展開する挙動を抑止
  event.preventDefault(); 
}

// ファイルの書き出し処理
function viewSaveMM() {
  // 配列に入っているのがそのままファイルの１行分
  var mes = new Array();
  for(i = 0; i < saveMM.length; i++) {
    mes[i] = saveMM[i]+"\n";
  }

  var blob;
  // Blobの作成
  blob = new Blob(mes);

  var disp = document.getElementById("disp");

  disp.innerHTML = "ファイルを書き出しました。（ ";
  // createObjectURLでテキストへのリンクを作成
  disp.innerHTML += '<a href="'+window.URL.createObjectURL(blob)+'" target="_blank">ダウンロード</a>';
  disp.innerHTML += " ）";
}

// 動作中のメッセージ出力
function focusedSSC() {
  var disp = document.getElementById("disp");
  disp.innerHTML = "動作中 - フォーカスされています。";
}

// 停止中のメッセージ出力
function unfocusedSSC() {
  var disp = document.getElementById("disp");
  disp.innerHTML = "停止中 - フォーカスが外れました。";
}
